<script setup lang="ts">
import type { Header, Item, ServerOptions } from "vue3-easy-data-table";
// import ConfirmationModal from "../Reference/components/ConfirmationModal.vue"
import Swal from 'sweetalert2'

import { useFormStore } from "@/stores/forms"
import { onMounted, ref, watch } from "vue";
import { useI18n } from 'vue-i18n'
const { t, locale } = useI18n()
import { useRoute } from "vue-router"
const route = useRoute()
console.log(route.path);

let isOpen = ref<boolean>(false)

const formStore = useFormStore()

const loading = ref(false);
const serverItemsLength = ref(0);
const serverOptions = ref<ServerOptions>({
    page: 1,
    rowsPerPage: 5
});

const deleteForm = (id: number) => {
    console.log(id);
    Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
    }).then((result) => {
        if (result.isConfirmed) {
            console.log(result);

        }
    })
}

async function getListForm() {
    loading.value = true;
    await formStore.getAllFormsList({ page: serverOptions.value.page, limit: serverOptions.value.rowsPerPage })
    serverItemsLength.value = formStore.getFormsList.data.total_count
    loading.value = false;
}

onMounted(() => {
    getListForm()

})

const headers: Header[] = [
    { text: "id", value: "id" },
    { text: "name", value: "name" },
    { text: "actions", value: "actions" },

];

const headerItemClassNameFunction = (header): string => {
    if (header.value === "actions") return "float-right mr-12";
    return "";
};


watch(
    serverOptions,
    (value) => {
        getListForm();
    },
    { deep: true }
);

</script>

<template>
    <div>
        <div class="flex items-center gap-2 uk-card uk-card-default uk-card-body uk-card-small rounded my-2">
            <div class="w-1/4">
                <label for="search">
                    {{ t('Search') }}
                    <input id="search" type="text" class="form-input" :placeholder="t('Search')">
                </label>
            </div>

            <div class="w-1/4">
                <label for="state">
                    {{ t('State') }}
                    <v-select id="state" :options="books" label="title" class="!rounded-md mt-1"
                        :placeholder="t('State')" />
                </label>
            </div>

            <div class="w-1/4">
                <label for="type_form">
                    {{ t('type_form') }}
                    <v-select id="type_form" label="title" class="!rounded-md mt-1" :placeholder="t('type_form')" />
                </label>
            </div>


        </div>
        <div class="flex items-center mb-2 ">
            <button class="btn-success w-1/12 ml-auto" @click="$router.push({ name: 'new-form' })">{{ t('Add') }}</button>
        </div>
        <div>
            <!-- {{ formStore.getFormsList.data.total_count }} -->
            <EasyDataTable buttons-pagination v-model:server-options="serverOptions" theme-color="#7367f0"
                :server-items-length="serverItemsLength" :loading="loading" id="user-table"
                :header-item-class-name="headerItemClassNameFunction" :headers="headers"
                :items="formStore.getFormsList.data.data" :rows-items="[5, 10, 15]" :rows-per-page="10">

                <template #empty-message>
                    <span>{{ t('empty_text') }}</span>
                </template>
                <template #header="data">
                    {{ t(data.text) }}
                </template>

                <template #item-name="item">
                    {{ item.name[locale.valueOf()] }}
                </template>

                <template #item-actions="item">
                    <div class="flex items-center justify-end gap-2">
                        <button class="btn-warning btn-action" @click="$router.push(`/form-detail/${item.id}`)">
                            <span uk-icon="icon: pencil" class="uk-icon"></span>
                        </button>
                        <button class="btn-danger btn-action" @click="deleteForm(item.id)">
                            <span uk-icon="icon: trash" class="uk-icon"></span>
                        </button>
                    </div>
                </template>
            </EasyDataTable>
        </div>

        <!-- <ConfirmationModal :isModalVisible="isOpen" v-model:test="isOpen" @update:state="getResult" /> -->
    </div>
</template>

<style>
.vue3-easy-data-table__loading-mask[data-v-19cc4b1b] {
    background-color: rgba(0, 0, 0, 0.1);
}
</style>